{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [],
   "source": [
    "import os, sys\n",
    "sys.path.append(os.path.abspath('src'))\n",
    "\n",
    "import src.hdf5_lib as h5lib\n",
    "import src.g5505_utils as utils\n",
    "\n",
    "\n",
    "# define input file directory\n",
    "\n",
    "input_file_path = './input_files\\\\BeamTimeMetaData.h5'\n",
    "output_dir_path = './output_files'\n",
    "if not os.path.exists(output_dir_path):\n",
    "    os.makedirs(output_dir_path)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Read the above specified input_file_path as a dataframe. \n",
    "\n",
    "Since we know this file was created from a Thorsten Table's format, we can use h5lib.read_mtable_as_dataframe() to read it.\n",
    "\n",
    "Then, we rename the 'name' column as 'filename', as this is the column's name use to idenfify files in subsequent functions.\n",
    "Also, we augment the dataframe with a few categorical columns to be used as grouping variables when creating the hdf5 file's group hierarchy. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [],
   "source": [
    "# Read BeamTimeMetaData.h5, containing Thorsten's Matlab Table\n",
    "input_data_df = h5lib.read_mtable_as_dataframe(input_file_path)\n",
    "\n",
    "# Preprocess Thorsten's input_data dataframe so that i can be used to create a newer .h5 file\n",
    "# under certain grouping specificiations.\n",
    "input_data_df = input_data_df.rename(columns = {'name':'filename'})\n",
    "input_data_df = utils.augment_with_filenumber(input_data_df)\n",
    "input_data_df = utils.augment_with_filetype(input_data_df)\n",
    "input_data_df = utils.split_sample_col_into_sample_and_data_quality_cols(input_data_df)\n",
    "input_data_df['lastModifiedDatestr'] = input_data_df['lastModifiedDatestr'].astype('datetime64[s]')\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "We now create a hdf5 file with a 3-level group hierarchy based on the input_data and three grouping functions. Then\n",
    "we visualize the group hierarchy of the created file as a treemap."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      ":)\n"
     ]
    },
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "config": {
        "plotlyServerURL": "https://plot.ly"
       },
       "data": [
        {
         "branchvalues": "remainder",
         "customdata": [
          "<br><br>Campaign name:SLS-Campaign-2023<br>Enddate:2023-09-25 09:37:13<br>Producers:Thorsten, Luca, Zoe<br>Startdate:2023-06-18 22:18:56",
          "/MgO crystal",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw/0002002",
          "/MgO crystal/ibw/0003003",
          "/MgO crystal/ibw/0004004",
          "/MgO crystal/ibw/0005005",
          "/MgO crystal/ibw/0006006",
          "/MgO crystal/ibw/0007007",
          "/MgO crystal/ibw/0008008",
          "/MgO crystal/ibw/0009009",
          "/MgO crystal/ibw/0010010",
          "/MgO crystal/ibw/0011011",
          "/MgO crystal/ibw/0012012",
          "/MgO crystal/ibw/0013013",
          "/MgO crystal/ibw/0014014",
          "/MgO crystal/ibw/0015015",
          "/MgO crystal/ibw/0016016",
          "/MgO crystal/ibw/0017017",
          "/MgO crystal/ibw/0018018",
          "/MgO crystal/ibw/0019019",
          "/MgO crystal/ibw/0020020",
          "/MgO crystal/ibw/0021021",
          "/MgO crystal/ibw/0022022",
          "/MgO crystal/ibw/0023023",
          "/MgO crystal,H2O",
          "/MgO crystal,H2O/ibw",
          "/MgO crystal,H2O/ibw/0034034",
          "/MgO crystal,H2O/ibw/0035035",
          "/MgO powder,H2O",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw/0036036",
          "/MgO powder,H2O/ibw/0037037",
          "/MgO powder,H2O/ibw/0038038",
          "/MgO powder,H2O/ibw/0039039",
          "/MgO powder,H2O/ibw/0040040",
          "/MgO powder,H2O/ibw/0056056",
          "/MgO powder,H2O/ibw/0057057",
          "/MgO powder,H2O/ibw/0058058",
          "/MgO powder,H2O/ibw/0059059",
          "/MgO powder,H2O/ibw/0060060",
          "/MgO powder,H2O/ibw/0061061",
          "/MgO powder,H2O/ibw/0062062",
          "/MgO powder,H2O/ibw/0063063",
          "/MgO powder,H2O/ibw/0064064",
          "/MgO powder,H2O/ibw/0065065",
          "/MgO powder,H2O/ibw/0066066",
          "/MgO powder,H2O/ibw/0067067",
          "/MgO powder,H2O/ibw/0068068",
          "/MgO powder,H2O/ibw/0069069",
          "/MgO powder,H2O/ibw/0085085",
          "/MgO powder,H2O/ibw/0086086",
          "/MgO powder,H2O/ibw/0087087",
          "/MgO powder,H2O/ibw/0088088",
          "/MgO powder,H2O/ibw/0089089",
          "/MgO powder,H2O/ibw/0090090",
          "/MgO powder,H2O/ibw/0091091",
          "/MgO powder,H2O/ibw/0092092",
          "/MgO powder,H2O/ibw/0097097",
          "/MgO powder,H2O/ibw/0098098",
          "/MgO powder,H2O/ibw/0099099",
          "/MgO powder,H2O ",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw/0103103",
          "/MgO powder,H2O /ibw/0104104",
          "/MgO powder,H2O /ibw/0105105",
          "/MgO powder,H2O /ibw/0106106",
          "/MgO powder,H2O /ibw/0128128",
          "/MgO powder,H2O,HCl",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw/0041041",
          "/MgO powder,H2O,HCl/ibw/0042042",
          "/MgO powder,H2O,HCl/ibw/0046046",
          "/MgO powder,H2O,HCl/ibw/0047047",
          "/MgO powder,H2O,HCl/ibw/0048048",
          "/MgO powder,H2O,HCl/ibw/0049049",
          "/MgO powder,H2O,HCl/ibw/0051051",
          "/MgO powder,H2O,HCl/ibw/0053053",
          "/MgO powder,H2O,HCl/ibw/0054054",
          "/MgO powder,H2O,HCl/ibw/0055055",
          "/MgO powder,H2O,HCl/ibw/0070070",
          "/MgO powder,H2O,HCl/ibw/0071071",
          "/MgO powder,H2O,HCl/ibw/0072072",
          "/MgO powder,H2O,HCl/ibw/0073073",
          "/MgO powder,H2O,HCl/ibw/0074074",
          "/MgO powder,H2O,HCl/ibw/0075075",
          "/MgO powder,H2O,HCl/ibw/0076076",
          "/MgO powder,H2O,HCl/ibw/0077077",
          "/MgO powder,H2O,HCl/ibw/0078078",
          "/MgO powder,H2O,HCl/ibw/0079079",
          "/MgO powder,H2O,HCl/ibw/0080080",
          "/MgO powder,H2O,HCl/ibw/0081081",
          "/MgO powder,H2O,HCl/ibw/0082082",
          "/MgO powder,H2O,HCl/ibw/0083083",
          "/MgO powder,H2O,HCl/ibw/0084084",
          "/MgO powder,H2O,HCl/ibw/0085085",
          "/MgO powder,H2O,HCl/ibw/0086086",
          "/MgO powder,H2O,HCl/ibw/0087087",
          "/MgO powder,H2O,HCl/ibw/0088088",
          "/MgO powder,H2O,HCl/ibw/0089089",
          "/MgO powder,H2O,HCl/ibw/0090090",
          "/MgO powder,H2O,HCl/ibw/0091091",
          "/MgO powder,H2O,HCl/ibw/0092092",
          "/MgO powder,H2O,HCl/ibw/0093093",
          "/MgO powder,H2O,HCl/ibw/0094094",
          "/MgO powder,H2O,HCl/ibw/0095095",
          "/MgO powder,H2O,HCl/ibw/0096096",
          "/MgO powder,H2O,HCl/ibw/0099099",
          "/MgO powder,H2O,HCl/ibw/0100100",
          "/MgO powder,H2O,HCl/ibw/0101101",
          "/MgO powder,H2O,HCl/ibw/0102102",
          "/MgO powder,H2O,HCl/ibw/0103103",
          "/MgO powder,H2O,HCl/ibw/0104104",
          "/MgO powder,H2O,HCl/ibw/0105105",
          "/MgO powder,H2O,HCl/ibw/0106106",
          "/MgO powder,H2O,HCl/ibw/0107107",
          "/MgO powder,H2O,HCl/ibw/0108108",
          "/MgO powder,H2O,HCl/ibw/0109109",
          "/MgO powder,H2O,HCl/ibw/0110110",
          "/MgO powder,H2O,HCl/ibw/0111111",
          "/MgO powder,H2O,HCl/ibw/0112112",
          "/MgO powder,H2O,HCl/ibw/0113113",
          "/MgO powder,H2O,HCl/ibw/0114114",
          "/MgO powder,H2O,HCl/ibw/0115115",
          "/MgO powder,H2O,HCl/ibw/0116116",
          "/MgO powder,H2O,HCl/ibw/0117117",
          "/MgO powder,H2O,HCl/ibw/0118118",
          "/MgO powder,H2O,HCl/ibw/0119119",
          "/MgO powder,H2O,HCl/ibw/0120120",
          "/MgO powder,H2O,HCl/ibw/0121121",
          "/MgO powder,H2O,HCl/ibw/0122122",
          "/MgO powder,H2O,HCl/ibw/0123123",
          "/MgO powder,H2O,HCl/ibw/0124124",
          "/MgO powder,H2O,HCl/ibw/0125125",
          "/MgO powder,H2O,HCl/ibw/0126126",
          "/MgO powder,H2O,HCl/ibw/0127127",
          "/MgO powder,H2O,HCl/ibw/0129129",
          "/MgO powder,H2O,HCl/ibw/0130130",
          "/MgO powder,H2O,HCl/ibw/0132132",
          "/MgO powder,H2O,HCl/ibw/0133133",
          "/MgO powder,H2O,HCl/ibw/0134134",
          "/MgO powder,H2O,HCl/ibw/0135135",
          "/MgO powder,H2O,HCl/ibw/0136136",
          "/MgO powder,H2O,HCl/ibw/0137137",
          "/MgO powder,H2O,HCl/ibw/0138138",
          "/MgO powder,H2O,HCl/ibw/0139139",
          "/MgO powder,H2O,HCl/ibw/0140140",
          "/MgO powder,H2O,HCl/ibw/0141141",
          "/MgO powder,H2O,HCl/ibw/0142142",
          "/MgO powder,H2O,HCl/ibw/0143143",
          "/MgO powder,H2O,HCl/ibw/0144144",
          "/MgO powder,H2O,HCl/ibw/0145145",
          "/MgO powder,H2O,HCl/ibw/0146146",
          "/MgO powder,H2O,HCl/ibw/0147147",
          "/MgO powder,H2O,HCl/ibw/0148148",
          "/MgO powder,H2O,HCl/ibw/0149149",
          "/MgO powder,H2O,HCl/ibw/0150150",
          "/MgO powder,H2O,HCl/ibw/0151151",
          "/MgO powder,H2O,HCl/ibw/0152152",
          "/MgO powder,H2O,HCl ",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw/0043043",
          "/MgO powder,H2O,HCl /ibw/0044044",
          "/MgO powder,H2O,HCl /ibw/0045045",
          "/MgO powder,H2O,HCl /ibw/0050050",
          "/MgO powder,H2O,HCl /ibw/0052052",
          "/MgO powder,H2O,HCl /ibw/0098098",
          "/Not yet annotated",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp/A001 - 20230922",
          "/Not yet annotated/bmp/A002 - 20230922",
          "/Not yet annotated/bmp/A003 - 20230922",
          "/Not yet annotated/bmp/A004 - 20230922",
          "/Not yet annotated/bmp/A005 - 20230922",
          "/Not yet annotated/bmp/A006 - 20230923",
          "/Not yet annotated/bmp/A007 - 20230923",
          "/Not yet annotated/bmp/A008 - 20230923",
          "/Not yet annotated/bmp/A009 - 20230923",
          "/Not yet annotated/bmp/A010 - 20230923",
          "/Not yet annotated/bmp/A011 - 20230923",
          "/Not yet annotated/bmp/A012 - 20230923",
          "/Not yet annotated/bmp/A013 - 20230923",
          "/Not yet annotated/bmp/A014 - 20230923",
          "/Not yet annotated/bmp/A015 - 20230923",
          "/Not yet annotated/bmp/A016 - 20230923",
          "/Not yet annotated/bmp/A017 - 20230923",
          "/Not yet annotated/bmp/A018 - 20230923",
          "/Not yet annotated/bmp/A019 - 20230923",
          "/Not yet annotated/bmp/A020 - 20230923",
          "/Not yet annotated/bmp/A021 - 20230923",
          "/Not yet annotated/bmp/A022 - 20230923",
          "/Not yet annotated/bmp/A023 - 20230923",
          "/Not yet annotated/bmp/A024 - 20230923",
          "/Not yet annotated/bmp/A025 - 20230923",
          "/Not yet annotated/bmp/A026 - 20230923",
          "/Not yet annotated/bmp/A027 - 20230923",
          "/Not yet annotated/bmp/A028 - 20230923",
          "/Not yet annotated/bmp/A029 - 20230923",
          "/Not yet annotated/bmp/A030 - 20230924",
          "/Not yet annotated/bmp/A031 - 20230924",
          "/Not yet annotated/bmp/A032 - 20230924",
          "/Not yet annotated/bmp/A033 - 20230924",
          "/Not yet annotated/bmp/A034 - 20230924",
          "/Not yet annotated/bmp/A035 - 20230924",
          "/Not yet annotated/bmp/A036 - 20230924",
          "/Not yet annotated/bmp/A037 - 20230924",
          "/Not yet annotated/bmp/A038 - 20230924",
          "/Not yet annotated/bmp/A039 - 20230924",
          "/Not yet annotated/bmp/A040 - 20230924",
          "/Not yet annotated/bmp/A041 - 20230924",
          "/Not yet annotated/bmp/A042 - 20230924",
          "/Not yet annotated/bmp/A043 - 20230924",
          "/Not yet annotated/bmp/A044 - 20230924",
          "/Not yet annotated/bmp/A045 - 20230924",
          "/Not yet annotated/bmp/A046 - 20230924",
          "/Not yet annotated/bmp/A047 - 20230924",
          "/Not yet annotated/bmp/A048 - 20230924",
          "/Not yet annotated/bmp/A049 - 20230924",
          "/Not yet annotated/bmp/A050 - 20230924",
          "/Not yet annotated/bmp/A051 - 20230924",
          "/Not yet annotated/bmp/A052 - 20230924",
          "/Not yet annotated/bmp/A053 - 20230924",
          "/Not yet annotated/bmp/A054 - 20230924",
          "/Not yet annotated/bmp/A055 - 20230924",
          "/Not yet annotated/bmp/A056 - 20230924",
          "/Not yet annotated/bmp/A057 - 20230924",
          "/Not yet annotated/bmp/A058 - 20230924",
          "/Not yet annotated/bmp/A059 - 20230924",
          "/Not yet annotated/bmp/A060 - 20230924",
          "/Not yet annotated/bmp/A061 - 20230924",
          "/Not yet annotated/bmp/A062 - 20230924",
          "/Not yet annotated/bmp/A063 - 20230924",
          "/Not yet annotated/bmp/A064 - 20230924",
          "/Not yet annotated/bmp/A065 - 20230924",
          "/Not yet annotated/bmp/A066 - 20230924",
          "/Not yet annotated/bmp/A067 - 20230925",
          "/Not yet annotated/bmp/A068 - 20230925",
          "/Not yet annotated/bmp/A069 - 20230925",
          "/Not yet annotated/bmp/A070 - 20230925",
          "/Not yet annotated/bmp/A071 - 20230925",
          "/Not yet annotated/bmp/A072 - 20230925",
          "/Not yet annotated/bmp/A073 - 20230925",
          "/Not yet annotated/bmp/A074 - 20230925",
          "/Not yet annotated/bmp/A075 - 20230925",
          "/Not yet annotated/bmp/A076 - 20230925",
          "/Not yet annotated/bmp/A077 - 20230925",
          "/Not yet annotated/bmp/A078 - 20230925",
          "/Not yet annotated/bmp/A079 - 20230925",
          "/Not yet annotated/bmp/A081 - 20230925",
          "/Not yet annotated/bmp/A082 - 20230925",
          "/Not yet annotated/bmp/A083 - 20230925",
          "/Not yet annotated/bmp/A084 - 20230925",
          "/Not yet annotated/bmp/A348 - 20230618",
          "/Not yet annotated/bmp/A349 - 20230619",
          "/Not yet annotated/bmp/A350 - 20230619",
          "/Not yet annotated/bmp/A351 - 20230619",
          "/Not yet annotated/bmp/A352 - 20230619",
          "/Not yet annotated/bmp/A353 - 20230621",
          "/Not yet annotated/bmp/A354 - 20230621",
          "/Not yet annotated/bmp/A355 - 20230621",
          "/Not yet annotated/bmp/A356 - 20230621",
          "/Not yet annotated/bmp/A357 - 20230621",
          "/Not yet annotated/bmp/A358 - 20230621",
          "/Not yet annotated/bmp/A359 - 20230621",
          "/Not yet annotated/bmp/A360 - 20230621",
          "/Not yet annotated/bmp/A361 - 20230621",
          "/Not yet annotated/bmp/A362 - 20230621",
          "/Not yet annotated/bmp/A363 - 20230621",
          "/Not yet annotated/bmp/A364 - 20230621",
          "/Not yet annotated/bmp/A365 - 20230621",
          "/Not yet annotated/bmp/A366 - 20230621",
          "/Not yet annotated/bmp/A367 - 20230621",
          "/Not yet annotated/bmp/A368 - 20230621",
          "/Not yet annotated/bmp/A369 - 20230621",
          "/Not yet annotated/bmp/A370 - 20230621",
          "/Not yet annotated/bmp/A371 - 20230622",
          "/Not yet annotated/bmp/A372 - 20230622",
          "/Not yet annotated/bmp/A373 - 20230622",
          "/Not yet annotated/bmp/A374 - 20230622",
          "/Not yet annotated/bmp/A375 - 20230622",
          "/Not yet annotated/bmp/A376 - 20230622",
          "/Not yet annotated/bmp/A377 - 20230622",
          "/Not yet annotated/bmp/A378 - 20230622",
          "/Not yet annotated/bmp/A379 - 20230622",
          "/Not yet annotated/bmp/A380 - 20230622",
          "/Not yet annotated/bmp/A381 - 20230622",
          "/Not yet annotated/bmp/A382 - 20230622",
          "/Not yet annotated/bmp/A383 - 20230622",
          "/Not yet annotated/bmp/A384 - 20230622",
          "/Not yet annotated/bmp/A385 - 20230622",
          "/Not yet annotated/bmp/A386 - 20230622",
          "/Not yet annotated/bmp/A387 - 20230622",
          "/Not yet annotated/bmp/A388 - 20230622",
          "/Not yet annotated/bmp/A389 - 20230622",
          "/Not yet annotated/bmp/A390 - 20230622",
          "/Not yet annotated/bmp/A391 - 20230622",
          "/Not yet annotated/bmp/A392 - 20230622",
          "/Not yet annotated/bmp/A393 - 20230623",
          "/Not yet annotated/bmp/A394 - 20230623",
          "/Not yet annotated/bmp/A395 - 20230623",
          "/Not yet annotated/bmp/A396 - 20230623",
          "/Not yet annotated/bmp/A397 - 20230623",
          "/Not yet annotated/bmp/A398 - 20230623",
          "/Not yet annotated/bmp/A399 - 20230623",
          "/Not yet annotated/bmp/A400 - 20230623",
          "/Not yet annotated/bmp/A401 - 20230623",
          "/Not yet annotated/bmp/A402 - 20230623",
          "/Not yet annotated/bmp/A403 - 20230623",
          "/Not yet annotated/bmp/A404 - 20230623",
          "/Not yet annotated/bmp/A405 - 20230623",
          "/Not yet annotated/bmp/A406 - 20230623",
          "/Not yet annotated/bmp/A407 - 20230623",
          "/Not yet annotated/bmp/A408 - 20230623",
          "/Not yet annotated/bmp/A409 - 20230623",
          "/Not yet annotated/bmp/A410 - 20230623",
          "/Not yet annotated/bmp/A411 - 20230624",
          "/Not yet annotated/bmp/A412 - 20230624",
          "/Not yet annotated/bmp/A413 - 20230624",
          "/Not yet annotated/bmp/A414 - 20230624",
          "/Not yet annotated/bmp/A415 - 20230624",
          "/Not yet annotated/bmp/A416 - 20230624",
          "/Not yet annotated/bmp/A417 - 20230624",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5/0000",
          "/Not yet annotated/h5/0001",
          "/Not yet annotated/h5/0002",
          "/Not yet annotated/h5/0048",
          "/Not yet annotated/h5/0049",
          "/Not yet annotated/h5/0050",
          "/Not yet annotated/h5/0051",
          "/Not yet annotated/h5/0052",
          "/Not yet annotated/h5/0053",
          "/Not yet annotated/h5/0054",
          "/Not yet annotated/h5/0055",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw/0001001",
          "/Not yet annotated/ibw/0002002",
          "/Not yet annotated/ibw/0003003",
          "/Not yet annotated/ibw/0004004",
          "/Not yet annotated/ibw/0005005",
          "/Not yet annotated/ibw/0006006",
          "/Not yet annotated/ibw/0007007",
          "/Not yet annotated/ibw/0008008",
          "/Not yet annotated/ibw/0009009",
          "/Not yet annotated/ibw/0011011",
          "/Not yet annotated/ibw/0012012",
          "/Not yet annotated/ibw/0013013",
          "/Not yet annotated/ibw/0014014",
          "/Not yet annotated/ibw/0015015",
          "/Not yet annotated/ibw/0016016",
          "/Not yet annotated/ibw/0017017",
          "/Not yet annotated/ibw/0018018",
          "/Not yet annotated/ibw/0019019",
          "/Not yet annotated/ibw/0020020",
          "/Not yet annotated/ibw/0021021",
          "/Not yet annotated/ibw/0022022",
          "/Not yet annotated/ibw/0023023",
          "/Not yet annotated/ibw/0024024",
          "/Not yet annotated/ibw/0025025",
          "/Not yet annotated/ibw/0026026",
          "/Not yet annotated/ibw/0027027",
          "/Not yet annotated/ibw/0028028",
          "/Not yet annotated/ibw/0029029",
          "/Not yet annotated/ibw/0030030",
          "/Not yet annotated/ibw/0031031",
          "/Not yet annotated/ibw/0032032",
          "/Not yet annotated/ibw/0033033",
          "/Not yet annotated/ibw/0034034",
          "/Not yet annotated/ibw/0035035",
          "/Not yet annotated/ibw/0036036",
          "/Not yet annotated/ibw/0037037",
          "/Not yet annotated/ibw/0038038",
          "/Not yet annotated/ibw/0039039",
          "/Not yet annotated/ibw/0040040",
          "/Not yet annotated/ibw/0041041",
          "/Not yet annotated/ibw/0042042",
          "/Not yet annotated/ibw/0044044",
          "/Not yet annotated/ibw/0045045",
          "/Not yet annotated/ibw/0046046",
          "/Not yet annotated/ibw/0047047",
          "/Not yet annotated/ibw/0048048",
          "/Not yet annotated/ibw/0049049",
          "/Not yet annotated/ibw/0051051",
          "/Not yet annotated/ibw/0052052",
          "/Not yet annotated/ibw/0053053",
          "/Not yet annotated/ibw/0054054",
          "/Not yet annotated/ibw/0055055",
          "/Not yet annotated/ibw/0056056",
          "/Not yet annotated/ibw/0057057",
          "/Not yet annotated/ibw/0058058",
          "/Not yet annotated/ibw/0059059",
          "/Not yet annotated/ibw/0060060",
          "/Not yet annotated/ibw/0061061",
          "/Not yet annotated/ibw/0063063",
          "/Not yet annotated/ibw/0064064",
          "/Not yet annotated/ibw/0065065",
          "/Not yet annotated/ibw/0066066",
          "/Not yet annotated/ibw/0068068",
          "/Not yet annotated/ibw/0069069",
          "/Not yet annotated/ibw/0070070",
          "/Not yet annotated/ibw/0071071",
          "/Not yet annotated/ibw/0072072",
          "/Not yet annotated/ibw/0073073",
          "/Not yet annotated/ibw/0074074",
          "/Not yet annotated/ibw/0075075",
          "/Not yet annotated/ibw/0076076",
          "/Not yet annotated/ibw/0077077",
          "/Not yet annotated/ibw/0078078",
          "/Not yet annotated/ibw/0079079",
          "/Not yet annotated/ibw/0080080",
          "/Not yet annotated/ibw/0081081",
          "/Not yet annotated/ibw/0082082",
          "/Not yet annotated/ibw/0083083",
          "/Not yet annotated/ibw/0084084",
          "/Not yet annotated/ibw/0100100",
          "/Not yet annotated/ibw/0101101",
          "/Not yet annotated/ibw/0102102",
          "/Not yet annotated/ibw/0131131",
          "/SiO2 crystal,H2O",
          "/SiO2 crystal,H2O/ibw",
          "/SiO2 crystal,H2O/ibw/0024024",
          "/SiO2 crystal,H2O/ibw/0025025",
          "/SiO2 crystal,H2O/ibw/0026026",
          "/SiO2 crystal,H2O, HCl",
          "/SiO2 crystal,H2O, HCl/ibw",
          "/SiO2 crystal,H2O, HCl/ibw/0027027",
          "/SiO2 crystal,H2O, HCl/ibw/0028028",
          "/SiO2 crystal,H2O, HCl/ibw/0029029",
          "/SiO2 crystal,HCl",
          "/SiO2 crystal,HCl/ibw",
          "/SiO2 crystal,HCl/ibw/0031031",
          "/SiO2 crystal,HCl/ibw/0032032",
          "/SiO2 crystal,HCl/ibw/0033033",
          "/sample holder",
          "/sample holder/ibw",
          "/sample holder/ibw/0001001"
         ],
         "hovertemplate": "<b>%{label} </b> <br> Count: %{value} <br> Path: %{customdata}",
         "labels": [
          "/",
          "/MgO crystal",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw/0002002",
          "/MgO crystal/ibw/0003003",
          "/MgO crystal/ibw/0004004",
          "/MgO crystal/ibw/0005005",
          "/MgO crystal/ibw/0006006",
          "/MgO crystal/ibw/0007007",
          "/MgO crystal/ibw/0008008",
          "/MgO crystal/ibw/0009009",
          "/MgO crystal/ibw/0010010",
          "/MgO crystal/ibw/0011011",
          "/MgO crystal/ibw/0012012",
          "/MgO crystal/ibw/0013013",
          "/MgO crystal/ibw/0014014",
          "/MgO crystal/ibw/0015015",
          "/MgO crystal/ibw/0016016",
          "/MgO crystal/ibw/0017017",
          "/MgO crystal/ibw/0018018",
          "/MgO crystal/ibw/0019019",
          "/MgO crystal/ibw/0020020",
          "/MgO crystal/ibw/0021021",
          "/MgO crystal/ibw/0022022",
          "/MgO crystal/ibw/0023023",
          "/MgO crystal,H2O",
          "/MgO crystal,H2O/ibw",
          "/MgO crystal,H2O/ibw/0034034",
          "/MgO crystal,H2O/ibw/0035035",
          "/MgO powder,H2O",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw/0036036",
          "/MgO powder,H2O/ibw/0037037",
          "/MgO powder,H2O/ibw/0038038",
          "/MgO powder,H2O/ibw/0039039",
          "/MgO powder,H2O/ibw/0040040",
          "/MgO powder,H2O/ibw/0056056",
          "/MgO powder,H2O/ibw/0057057",
          "/MgO powder,H2O/ibw/0058058",
          "/MgO powder,H2O/ibw/0059059",
          "/MgO powder,H2O/ibw/0060060",
          "/MgO powder,H2O/ibw/0061061",
          "/MgO powder,H2O/ibw/0062062",
          "/MgO powder,H2O/ibw/0063063",
          "/MgO powder,H2O/ibw/0064064",
          "/MgO powder,H2O/ibw/0065065",
          "/MgO powder,H2O/ibw/0066066",
          "/MgO powder,H2O/ibw/0067067",
          "/MgO powder,H2O/ibw/0068068",
          "/MgO powder,H2O/ibw/0069069",
          "/MgO powder,H2O/ibw/0085085",
          "/MgO powder,H2O/ibw/0086086",
          "/MgO powder,H2O/ibw/0087087",
          "/MgO powder,H2O/ibw/0088088",
          "/MgO powder,H2O/ibw/0089089",
          "/MgO powder,H2O/ibw/0090090",
          "/MgO powder,H2O/ibw/0091091",
          "/MgO powder,H2O/ibw/0092092",
          "/MgO powder,H2O/ibw/0097097",
          "/MgO powder,H2O/ibw/0098098",
          "/MgO powder,H2O/ibw/0099099",
          "/MgO powder,H2O ",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw/0103103",
          "/MgO powder,H2O /ibw/0104104",
          "/MgO powder,H2O /ibw/0105105",
          "/MgO powder,H2O /ibw/0106106",
          "/MgO powder,H2O /ibw/0128128",
          "/MgO powder,H2O,HCl",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw/0041041",
          "/MgO powder,H2O,HCl/ibw/0042042",
          "/MgO powder,H2O,HCl/ibw/0046046",
          "/MgO powder,H2O,HCl/ibw/0047047",
          "/MgO powder,H2O,HCl/ibw/0048048",
          "/MgO powder,H2O,HCl/ibw/0049049",
          "/MgO powder,H2O,HCl/ibw/0051051",
          "/MgO powder,H2O,HCl/ibw/0053053",
          "/MgO powder,H2O,HCl/ibw/0054054",
          "/MgO powder,H2O,HCl/ibw/0055055",
          "/MgO powder,H2O,HCl/ibw/0070070",
          "/MgO powder,H2O,HCl/ibw/0071071",
          "/MgO powder,H2O,HCl/ibw/0072072",
          "/MgO powder,H2O,HCl/ibw/0073073",
          "/MgO powder,H2O,HCl/ibw/0074074",
          "/MgO powder,H2O,HCl/ibw/0075075",
          "/MgO powder,H2O,HCl/ibw/0076076",
          "/MgO powder,H2O,HCl/ibw/0077077",
          "/MgO powder,H2O,HCl/ibw/0078078",
          "/MgO powder,H2O,HCl/ibw/0079079",
          "/MgO powder,H2O,HCl/ibw/0080080",
          "/MgO powder,H2O,HCl/ibw/0081081",
          "/MgO powder,H2O,HCl/ibw/0082082",
          "/MgO powder,H2O,HCl/ibw/0083083",
          "/MgO powder,H2O,HCl/ibw/0084084",
          "/MgO powder,H2O,HCl/ibw/0085085",
          "/MgO powder,H2O,HCl/ibw/0086086",
          "/MgO powder,H2O,HCl/ibw/0087087",
          "/MgO powder,H2O,HCl/ibw/0088088",
          "/MgO powder,H2O,HCl/ibw/0089089",
          "/MgO powder,H2O,HCl/ibw/0090090",
          "/MgO powder,H2O,HCl/ibw/0091091",
          "/MgO powder,H2O,HCl/ibw/0092092",
          "/MgO powder,H2O,HCl/ibw/0093093",
          "/MgO powder,H2O,HCl/ibw/0094094",
          "/MgO powder,H2O,HCl/ibw/0095095",
          "/MgO powder,H2O,HCl/ibw/0096096",
          "/MgO powder,H2O,HCl/ibw/0099099",
          "/MgO powder,H2O,HCl/ibw/0100100",
          "/MgO powder,H2O,HCl/ibw/0101101",
          "/MgO powder,H2O,HCl/ibw/0102102",
          "/MgO powder,H2O,HCl/ibw/0103103",
          "/MgO powder,H2O,HCl/ibw/0104104",
          "/MgO powder,H2O,HCl/ibw/0105105",
          "/MgO powder,H2O,HCl/ibw/0106106",
          "/MgO powder,H2O,HCl/ibw/0107107",
          "/MgO powder,H2O,HCl/ibw/0108108",
          "/MgO powder,H2O,HCl/ibw/0109109",
          "/MgO powder,H2O,HCl/ibw/0110110",
          "/MgO powder,H2O,HCl/ibw/0111111",
          "/MgO powder,H2O,HCl/ibw/0112112",
          "/MgO powder,H2O,HCl/ibw/0113113",
          "/MgO powder,H2O,HCl/ibw/0114114",
          "/MgO powder,H2O,HCl/ibw/0115115",
          "/MgO powder,H2O,HCl/ibw/0116116",
          "/MgO powder,H2O,HCl/ibw/0117117",
          "/MgO powder,H2O,HCl/ibw/0118118",
          "/MgO powder,H2O,HCl/ibw/0119119",
          "/MgO powder,H2O,HCl/ibw/0120120",
          "/MgO powder,H2O,HCl/ibw/0121121",
          "/MgO powder,H2O,HCl/ibw/0122122",
          "/MgO powder,H2O,HCl/ibw/0123123",
          "/MgO powder,H2O,HCl/ibw/0124124",
          "/MgO powder,H2O,HCl/ibw/0125125",
          "/MgO powder,H2O,HCl/ibw/0126126",
          "/MgO powder,H2O,HCl/ibw/0127127",
          "/MgO powder,H2O,HCl/ibw/0129129",
          "/MgO powder,H2O,HCl/ibw/0130130",
          "/MgO powder,H2O,HCl/ibw/0132132",
          "/MgO powder,H2O,HCl/ibw/0133133",
          "/MgO powder,H2O,HCl/ibw/0134134",
          "/MgO powder,H2O,HCl/ibw/0135135",
          "/MgO powder,H2O,HCl/ibw/0136136",
          "/MgO powder,H2O,HCl/ibw/0137137",
          "/MgO powder,H2O,HCl/ibw/0138138",
          "/MgO powder,H2O,HCl/ibw/0139139",
          "/MgO powder,H2O,HCl/ibw/0140140",
          "/MgO powder,H2O,HCl/ibw/0141141",
          "/MgO powder,H2O,HCl/ibw/0142142",
          "/MgO powder,H2O,HCl/ibw/0143143",
          "/MgO powder,H2O,HCl/ibw/0144144",
          "/MgO powder,H2O,HCl/ibw/0145145",
          "/MgO powder,H2O,HCl/ibw/0146146",
          "/MgO powder,H2O,HCl/ibw/0147147",
          "/MgO powder,H2O,HCl/ibw/0148148",
          "/MgO powder,H2O,HCl/ibw/0149149",
          "/MgO powder,H2O,HCl/ibw/0150150",
          "/MgO powder,H2O,HCl/ibw/0151151",
          "/MgO powder,H2O,HCl/ibw/0152152",
          "/MgO powder,H2O,HCl ",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw/0043043",
          "/MgO powder,H2O,HCl /ibw/0044044",
          "/MgO powder,H2O,HCl /ibw/0045045",
          "/MgO powder,H2O,HCl /ibw/0050050",
          "/MgO powder,H2O,HCl /ibw/0052052",
          "/MgO powder,H2O,HCl /ibw/0098098",
          "/Not yet annotated",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp/A001 - 20230922",
          "/Not yet annotated/bmp/A002 - 20230922",
          "/Not yet annotated/bmp/A003 - 20230922",
          "/Not yet annotated/bmp/A004 - 20230922",
          "/Not yet annotated/bmp/A005 - 20230922",
          "/Not yet annotated/bmp/A006 - 20230923",
          "/Not yet annotated/bmp/A007 - 20230923",
          "/Not yet annotated/bmp/A008 - 20230923",
          "/Not yet annotated/bmp/A009 - 20230923",
          "/Not yet annotated/bmp/A010 - 20230923",
          "/Not yet annotated/bmp/A011 - 20230923",
          "/Not yet annotated/bmp/A012 - 20230923",
          "/Not yet annotated/bmp/A013 - 20230923",
          "/Not yet annotated/bmp/A014 - 20230923",
          "/Not yet annotated/bmp/A015 - 20230923",
          "/Not yet annotated/bmp/A016 - 20230923",
          "/Not yet annotated/bmp/A017 - 20230923",
          "/Not yet annotated/bmp/A018 - 20230923",
          "/Not yet annotated/bmp/A019 - 20230923",
          "/Not yet annotated/bmp/A020 - 20230923",
          "/Not yet annotated/bmp/A021 - 20230923",
          "/Not yet annotated/bmp/A022 - 20230923",
          "/Not yet annotated/bmp/A023 - 20230923",
          "/Not yet annotated/bmp/A024 - 20230923",
          "/Not yet annotated/bmp/A025 - 20230923",
          "/Not yet annotated/bmp/A026 - 20230923",
          "/Not yet annotated/bmp/A027 - 20230923",
          "/Not yet annotated/bmp/A028 - 20230923",
          "/Not yet annotated/bmp/A029 - 20230923",
          "/Not yet annotated/bmp/A030 - 20230924",
          "/Not yet annotated/bmp/A031 - 20230924",
          "/Not yet annotated/bmp/A032 - 20230924",
          "/Not yet annotated/bmp/A033 - 20230924",
          "/Not yet annotated/bmp/A034 - 20230924",
          "/Not yet annotated/bmp/A035 - 20230924",
          "/Not yet annotated/bmp/A036 - 20230924",
          "/Not yet annotated/bmp/A037 - 20230924",
          "/Not yet annotated/bmp/A038 - 20230924",
          "/Not yet annotated/bmp/A039 - 20230924",
          "/Not yet annotated/bmp/A040 - 20230924",
          "/Not yet annotated/bmp/A041 - 20230924",
          "/Not yet annotated/bmp/A042 - 20230924",
          "/Not yet annotated/bmp/A043 - 20230924",
          "/Not yet annotated/bmp/A044 - 20230924",
          "/Not yet annotated/bmp/A045 - 20230924",
          "/Not yet annotated/bmp/A046 - 20230924",
          "/Not yet annotated/bmp/A047 - 20230924",
          "/Not yet annotated/bmp/A048 - 20230924",
          "/Not yet annotated/bmp/A049 - 20230924",
          "/Not yet annotated/bmp/A050 - 20230924",
          "/Not yet annotated/bmp/A051 - 20230924",
          "/Not yet annotated/bmp/A052 - 20230924",
          "/Not yet annotated/bmp/A053 - 20230924",
          "/Not yet annotated/bmp/A054 - 20230924",
          "/Not yet annotated/bmp/A055 - 20230924",
          "/Not yet annotated/bmp/A056 - 20230924",
          "/Not yet annotated/bmp/A057 - 20230924",
          "/Not yet annotated/bmp/A058 - 20230924",
          "/Not yet annotated/bmp/A059 - 20230924",
          "/Not yet annotated/bmp/A060 - 20230924",
          "/Not yet annotated/bmp/A061 - 20230924",
          "/Not yet annotated/bmp/A062 - 20230924",
          "/Not yet annotated/bmp/A063 - 20230924",
          "/Not yet annotated/bmp/A064 - 20230924",
          "/Not yet annotated/bmp/A065 - 20230924",
          "/Not yet annotated/bmp/A066 - 20230924",
          "/Not yet annotated/bmp/A067 - 20230925",
          "/Not yet annotated/bmp/A068 - 20230925",
          "/Not yet annotated/bmp/A069 - 20230925",
          "/Not yet annotated/bmp/A070 - 20230925",
          "/Not yet annotated/bmp/A071 - 20230925",
          "/Not yet annotated/bmp/A072 - 20230925",
          "/Not yet annotated/bmp/A073 - 20230925",
          "/Not yet annotated/bmp/A074 - 20230925",
          "/Not yet annotated/bmp/A075 - 20230925",
          "/Not yet annotated/bmp/A076 - 20230925",
          "/Not yet annotated/bmp/A077 - 20230925",
          "/Not yet annotated/bmp/A078 - 20230925",
          "/Not yet annotated/bmp/A079 - 20230925",
          "/Not yet annotated/bmp/A081 - 20230925",
          "/Not yet annotated/bmp/A082 - 20230925",
          "/Not yet annotated/bmp/A083 - 20230925",
          "/Not yet annotated/bmp/A084 - 20230925",
          "/Not yet annotated/bmp/A348 - 20230618",
          "/Not yet annotated/bmp/A349 - 20230619",
          "/Not yet annotated/bmp/A350 - 20230619",
          "/Not yet annotated/bmp/A351 - 20230619",
          "/Not yet annotated/bmp/A352 - 20230619",
          "/Not yet annotated/bmp/A353 - 20230621",
          "/Not yet annotated/bmp/A354 - 20230621",
          "/Not yet annotated/bmp/A355 - 20230621",
          "/Not yet annotated/bmp/A356 - 20230621",
          "/Not yet annotated/bmp/A357 - 20230621",
          "/Not yet annotated/bmp/A358 - 20230621",
          "/Not yet annotated/bmp/A359 - 20230621",
          "/Not yet annotated/bmp/A360 - 20230621",
          "/Not yet annotated/bmp/A361 - 20230621",
          "/Not yet annotated/bmp/A362 - 20230621",
          "/Not yet annotated/bmp/A363 - 20230621",
          "/Not yet annotated/bmp/A364 - 20230621",
          "/Not yet annotated/bmp/A365 - 20230621",
          "/Not yet annotated/bmp/A366 - 20230621",
          "/Not yet annotated/bmp/A367 - 20230621",
          "/Not yet annotated/bmp/A368 - 20230621",
          "/Not yet annotated/bmp/A369 - 20230621",
          "/Not yet annotated/bmp/A370 - 20230621",
          "/Not yet annotated/bmp/A371 - 20230622",
          "/Not yet annotated/bmp/A372 - 20230622",
          "/Not yet annotated/bmp/A373 - 20230622",
          "/Not yet annotated/bmp/A374 - 20230622",
          "/Not yet annotated/bmp/A375 - 20230622",
          "/Not yet annotated/bmp/A376 - 20230622",
          "/Not yet annotated/bmp/A377 - 20230622",
          "/Not yet annotated/bmp/A378 - 20230622",
          "/Not yet annotated/bmp/A379 - 20230622",
          "/Not yet annotated/bmp/A380 - 20230622",
          "/Not yet annotated/bmp/A381 - 20230622",
          "/Not yet annotated/bmp/A382 - 20230622",
          "/Not yet annotated/bmp/A383 - 20230622",
          "/Not yet annotated/bmp/A384 - 20230622",
          "/Not yet annotated/bmp/A385 - 20230622",
          "/Not yet annotated/bmp/A386 - 20230622",
          "/Not yet annotated/bmp/A387 - 20230622",
          "/Not yet annotated/bmp/A388 - 20230622",
          "/Not yet annotated/bmp/A389 - 20230622",
          "/Not yet annotated/bmp/A390 - 20230622",
          "/Not yet annotated/bmp/A391 - 20230622",
          "/Not yet annotated/bmp/A392 - 20230622",
          "/Not yet annotated/bmp/A393 - 20230623",
          "/Not yet annotated/bmp/A394 - 20230623",
          "/Not yet annotated/bmp/A395 - 20230623",
          "/Not yet annotated/bmp/A396 - 20230623",
          "/Not yet annotated/bmp/A397 - 20230623",
          "/Not yet annotated/bmp/A398 - 20230623",
          "/Not yet annotated/bmp/A399 - 20230623",
          "/Not yet annotated/bmp/A400 - 20230623",
          "/Not yet annotated/bmp/A401 - 20230623",
          "/Not yet annotated/bmp/A402 - 20230623",
          "/Not yet annotated/bmp/A403 - 20230623",
          "/Not yet annotated/bmp/A404 - 20230623",
          "/Not yet annotated/bmp/A405 - 20230623",
          "/Not yet annotated/bmp/A406 - 20230623",
          "/Not yet annotated/bmp/A407 - 20230623",
          "/Not yet annotated/bmp/A408 - 20230623",
          "/Not yet annotated/bmp/A409 - 20230623",
          "/Not yet annotated/bmp/A410 - 20230623",
          "/Not yet annotated/bmp/A411 - 20230624",
          "/Not yet annotated/bmp/A412 - 20230624",
          "/Not yet annotated/bmp/A413 - 20230624",
          "/Not yet annotated/bmp/A414 - 20230624",
          "/Not yet annotated/bmp/A415 - 20230624",
          "/Not yet annotated/bmp/A416 - 20230624",
          "/Not yet annotated/bmp/A417 - 20230624",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5/0000",
          "/Not yet annotated/h5/0001",
          "/Not yet annotated/h5/0002",
          "/Not yet annotated/h5/0048",
          "/Not yet annotated/h5/0049",
          "/Not yet annotated/h5/0050",
          "/Not yet annotated/h5/0051",
          "/Not yet annotated/h5/0052",
          "/Not yet annotated/h5/0053",
          "/Not yet annotated/h5/0054",
          "/Not yet annotated/h5/0055",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw/0001001",
          "/Not yet annotated/ibw/0002002",
          "/Not yet annotated/ibw/0003003",
          "/Not yet annotated/ibw/0004004",
          "/Not yet annotated/ibw/0005005",
          "/Not yet annotated/ibw/0006006",
          "/Not yet annotated/ibw/0007007",
          "/Not yet annotated/ibw/0008008",
          "/Not yet annotated/ibw/0009009",
          "/Not yet annotated/ibw/0011011",
          "/Not yet annotated/ibw/0012012",
          "/Not yet annotated/ibw/0013013",
          "/Not yet annotated/ibw/0014014",
          "/Not yet annotated/ibw/0015015",
          "/Not yet annotated/ibw/0016016",
          "/Not yet annotated/ibw/0017017",
          "/Not yet annotated/ibw/0018018",
          "/Not yet annotated/ibw/0019019",
          "/Not yet annotated/ibw/0020020",
          "/Not yet annotated/ibw/0021021",
          "/Not yet annotated/ibw/0022022",
          "/Not yet annotated/ibw/0023023",
          "/Not yet annotated/ibw/0024024",
          "/Not yet annotated/ibw/0025025",
          "/Not yet annotated/ibw/0026026",
          "/Not yet annotated/ibw/0027027",
          "/Not yet annotated/ibw/0028028",
          "/Not yet annotated/ibw/0029029",
          "/Not yet annotated/ibw/0030030",
          "/Not yet annotated/ibw/0031031",
          "/Not yet annotated/ibw/0032032",
          "/Not yet annotated/ibw/0033033",
          "/Not yet annotated/ibw/0034034",
          "/Not yet annotated/ibw/0035035",
          "/Not yet annotated/ibw/0036036",
          "/Not yet annotated/ibw/0037037",
          "/Not yet annotated/ibw/0038038",
          "/Not yet annotated/ibw/0039039",
          "/Not yet annotated/ibw/0040040",
          "/Not yet annotated/ibw/0041041",
          "/Not yet annotated/ibw/0042042",
          "/Not yet annotated/ibw/0044044",
          "/Not yet annotated/ibw/0045045",
          "/Not yet annotated/ibw/0046046",
          "/Not yet annotated/ibw/0047047",
          "/Not yet annotated/ibw/0048048",
          "/Not yet annotated/ibw/0049049",
          "/Not yet annotated/ibw/0051051",
          "/Not yet annotated/ibw/0052052",
          "/Not yet annotated/ibw/0053053",
          "/Not yet annotated/ibw/0054054",
          "/Not yet annotated/ibw/0055055",
          "/Not yet annotated/ibw/0056056",
          "/Not yet annotated/ibw/0057057",
          "/Not yet annotated/ibw/0058058",
          "/Not yet annotated/ibw/0059059",
          "/Not yet annotated/ibw/0060060",
          "/Not yet annotated/ibw/0061061",
          "/Not yet annotated/ibw/0063063",
          "/Not yet annotated/ibw/0064064",
          "/Not yet annotated/ibw/0065065",
          "/Not yet annotated/ibw/0066066",
          "/Not yet annotated/ibw/0068068",
          "/Not yet annotated/ibw/0069069",
          "/Not yet annotated/ibw/0070070",
          "/Not yet annotated/ibw/0071071",
          "/Not yet annotated/ibw/0072072",
          "/Not yet annotated/ibw/0073073",
          "/Not yet annotated/ibw/0074074",
          "/Not yet annotated/ibw/0075075",
          "/Not yet annotated/ibw/0076076",
          "/Not yet annotated/ibw/0077077",
          "/Not yet annotated/ibw/0078078",
          "/Not yet annotated/ibw/0079079",
          "/Not yet annotated/ibw/0080080",
          "/Not yet annotated/ibw/0081081",
          "/Not yet annotated/ibw/0082082",
          "/Not yet annotated/ibw/0083083",
          "/Not yet annotated/ibw/0084084",
          "/Not yet annotated/ibw/0100100",
          "/Not yet annotated/ibw/0101101",
          "/Not yet annotated/ibw/0102102",
          "/Not yet annotated/ibw/0131131",
          "/SiO2 crystal,H2O",
          "/SiO2 crystal,H2O/ibw",
          "/SiO2 crystal,H2O/ibw/0024024",
          "/SiO2 crystal,H2O/ibw/0025025",
          "/SiO2 crystal,H2O/ibw/0026026",
          "/SiO2 crystal,H2O, HCl",
          "/SiO2 crystal,H2O, HCl/ibw",
          "/SiO2 crystal,H2O, HCl/ibw/0027027",
          "/SiO2 crystal,H2O, HCl/ibw/0028028",
          "/SiO2 crystal,H2O, HCl/ibw/0029029",
          "/SiO2 crystal,HCl",
          "/SiO2 crystal,HCl/ibw",
          "/SiO2 crystal,HCl/ibw/0031031",
          "/SiO2 crystal,HCl/ibw/0032032",
          "/SiO2 crystal,HCl/ibw/0033033",
          "/sample holder",
          "/sample holder/ibw",
          "/sample holder/ibw/0001001"
         ],
         "name": "",
         "parents": [
          "",
          "/",
          "/MgO crystal",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/MgO crystal/ibw",
          "/",
          "/MgO crystal,H2O",
          "/MgO crystal,H2O/ibw",
          "/MgO crystal,H2O/ibw",
          "/",
          "/MgO powder,H2O",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/MgO powder,H2O/ibw",
          "/",
          "/MgO powder,H2O ",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw",
          "/MgO powder,H2O /ibw",
          "/",
          "/MgO powder,H2O,HCl",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/MgO powder,H2O,HCl/ibw",
          "/",
          "/MgO powder,H2O,HCl ",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw",
          "/MgO powder,H2O,HCl /ibw",
          "/",
          "/Not yet annotated",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated/bmp",
          "/Not yet annotated",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated/h5",
          "/Not yet annotated",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/Not yet annotated/ibw",
          "/",
          "/SiO2 crystal,H2O",
          "/SiO2 crystal,H2O/ibw",
          "/SiO2 crystal,H2O/ibw",
          "/SiO2 crystal,H2O/ibw",
          "/",
          "/SiO2 crystal,H2O, HCl",
          "/SiO2 crystal,H2O, HCl/ibw",
          "/SiO2 crystal,H2O, HCl/ibw",
          "/SiO2 crystal,H2O, HCl/ibw",
          "/",
          "/SiO2 crystal,HCl",
          "/SiO2 crystal,HCl/ibw",
          "/SiO2 crystal,HCl/ibw",
          "/SiO2 crystal,HCl/ibw",
          "/",
          "/sample holder",
          "/sample holder/ibw"
         ],
         "root": {
          "color": "lightgrey"
         },
         "type": "treemap",
         "values": [
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1,
          1
         ]
        }
       ],
       "layout": {
        "height": 600,
        "margin": {
         "b": 25,
         "l": 25,
         "r": 25,
         "t": 50
        },
        "template": {
         "data": {
          "bar": [
           {
            "error_x": {
             "color": "#2a3f5f"
            },
            "error_y": {
             "color": "#2a3f5f"
            },
            "marker": {
             "line": {
              "color": "#E5ECF6",
              "width": 0.5
             },
             "pattern": {
              "fillmode": "overlay",
              "size": 10,
              "solidity": 0.2
             }
            },
            "type": "bar"
           }
          ],
          "barpolar": [
           {
            "marker": {
             "line": {
              "color": "#E5ECF6",
              "width": 0.5
             },
             "pattern": {
              "fillmode": "overlay",
              "size": 10,
              "solidity": 0.2
             }
            },
            "type": "barpolar"
           }
          ],
          "carpet": [
           {
            "aaxis": {
             "endlinecolor": "#2a3f5f",
             "gridcolor": "white",
             "linecolor": "white",
             "minorgridcolor": "white",
             "startlinecolor": "#2a3f5f"
            },
            "baxis": {
             "endlinecolor": "#2a3f5f",
             "gridcolor": "white",
             "linecolor": "white",
             "minorgridcolor": "white",
             "startlinecolor": "#2a3f5f"
            },
            "type": "carpet"
           }
          ],
          "choropleth": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "type": "choropleth"
           }
          ],
          "contour": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "contour"
           }
          ],
          "contourcarpet": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "type": "contourcarpet"
           }
          ],
          "heatmap": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "heatmap"
           }
          ],
          "heatmapgl": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "heatmapgl"
           }
          ],
          "histogram": [
           {
            "marker": {
             "pattern": {
              "fillmode": "overlay",
              "size": 10,
              "solidity": 0.2
             }
            },
            "type": "histogram"
           }
          ],
          "histogram2d": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "histogram2d"
           }
          ],
          "histogram2dcontour": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "histogram2dcontour"
           }
          ],
          "mesh3d": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "type": "mesh3d"
           }
          ],
          "parcoords": [
           {
            "line": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "parcoords"
           }
          ],
          "pie": [
           {
            "automargin": true,
            "type": "pie"
           }
          ],
          "scatter": [
           {
            "fillpattern": {
             "fillmode": "overlay",
             "size": 10,
             "solidity": 0.2
            },
            "type": "scatter"
           }
          ],
          "scatter3d": [
           {
            "line": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scatter3d"
           }
          ],
          "scattercarpet": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scattercarpet"
           }
          ],
          "scattergeo": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scattergeo"
           }
          ],
          "scattergl": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scattergl"
           }
          ],
          "scattermapbox": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scattermapbox"
           }
          ],
          "scatterpolar": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scatterpolar"
           }
          ],
          "scatterpolargl": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scatterpolargl"
           }
          ],
          "scatterternary": [
           {
            "marker": {
             "colorbar": {
              "outlinewidth": 0,
              "ticks": ""
             }
            },
            "type": "scatterternary"
           }
          ],
          "surface": [
           {
            "colorbar": {
             "outlinewidth": 0,
             "ticks": ""
            },
            "colorscale": [
             [
              0,
              "#0d0887"
             ],
             [
              0.1111111111111111,
              "#46039f"
             ],
             [
              0.2222222222222222,
              "#7201a8"
             ],
             [
              0.3333333333333333,
              "#9c179e"
             ],
             [
              0.4444444444444444,
              "#bd3786"
             ],
             [
              0.5555555555555556,
              "#d8576b"
             ],
             [
              0.6666666666666666,
              "#ed7953"
             ],
             [
              0.7777777777777778,
              "#fb9f3a"
             ],
             [
              0.8888888888888888,
              "#fdca26"
             ],
             [
              1,
              "#f0f921"
             ]
            ],
            "type": "surface"
           }
          ],
          "table": [
           {
            "cells": {
             "fill": {
              "color": "#EBF0F8"
             },
             "line": {
              "color": "white"
             }
            },
            "header": {
             "fill": {
              "color": "#C8D4E3"
             },
             "line": {
              "color": "white"
             }
            },
            "type": "table"
           }
          ]
         },
         "layout": {
          "annotationdefaults": {
           "arrowcolor": "#2a3f5f",
           "arrowhead": 0,
           "arrowwidth": 1
          },
          "autotypenumbers": "strict",
          "coloraxis": {
           "colorbar": {
            "outlinewidth": 0,
            "ticks": ""
           }
          },
          "colorscale": {
           "diverging": [
            [
             0,
             "#8e0152"
            ],
            [
             0.1,
             "#c51b7d"
            ],
            [
             0.2,
             "#de77ae"
            ],
            [
             0.3,
             "#f1b6da"
            ],
            [
             0.4,
             "#fde0ef"
            ],
            [
             0.5,
             "#f7f7f7"
            ],
            [
             0.6,
             "#e6f5d0"
            ],
            [
             0.7,
             "#b8e186"
            ],
            [
             0.8,
             "#7fbc41"
            ],
            [
             0.9,
             "#4d9221"
            ],
            [
             1,
             "#276419"
            ]
           ],
           "sequential": [
            [
             0,
             "#0d0887"
            ],
            [
             0.1111111111111111,
             "#46039f"
            ],
            [
             0.2222222222222222,
             "#7201a8"
            ],
            [
             0.3333333333333333,
             "#9c179e"
            ],
            [
             0.4444444444444444,
             "#bd3786"
            ],
            [
             0.5555555555555556,
             "#d8576b"
            ],
            [
             0.6666666666666666,
             "#ed7953"
            ],
            [
             0.7777777777777778,
             "#fb9f3a"
            ],
            [
             0.8888888888888888,
             "#fdca26"
            ],
            [
             1,
             "#f0f921"
            ]
           ],
           "sequentialminus": [
            [
             0,
             "#0d0887"
            ],
            [
             0.1111111111111111,
             "#46039f"
            ],
            [
             0.2222222222222222,
             "#7201a8"
            ],
            [
             0.3333333333333333,
             "#9c179e"
            ],
            [
             0.4444444444444444,
             "#bd3786"
            ],
            [
             0.5555555555555556,
             "#d8576b"
            ],
            [
             0.6666666666666666,
             "#ed7953"
            ],
            [
             0.7777777777777778,
             "#fb9f3a"
            ],
            [
             0.8888888888888888,
             "#fdca26"
            ],
            [
             1,
             "#f0f921"
            ]
           ]
          },
          "colorway": [
           "#636efa",
           "#EF553B",
           "#00cc96",
           "#ab63fa",
           "#FFA15A",
           "#19d3f3",
           "#FF6692",
           "#B6E880",
           "#FF97FF",
           "#FECB52"
          ],
          "font": {
           "color": "#2a3f5f"
          },
          "geo": {
           "bgcolor": "white",
           "lakecolor": "white",
           "landcolor": "#E5ECF6",
           "showlakes": true,
           "showland": true,
           "subunitcolor": "white"
          },
          "hoverlabel": {
           "align": "left"
          },
          "hovermode": "closest",
          "mapbox": {
           "style": "light"
          },
          "paper_bgcolor": "white",
          "plot_bgcolor": "#E5ECF6",
          "polar": {
           "angularaxis": {
            "gridcolor": "white",
            "linecolor": "white",
            "ticks": ""
           },
           "bgcolor": "#E5ECF6",
           "radialaxis": {
            "gridcolor": "white",
            "linecolor": "white",
            "ticks": ""
           }
          },
          "scene": {
           "xaxis": {
            "backgroundcolor": "#E5ECF6",
            "gridcolor": "white",
            "gridwidth": 2,
            "linecolor": "white",
            "showbackground": true,
            "ticks": "",
            "zerolinecolor": "white"
           },
           "yaxis": {
            "backgroundcolor": "#E5ECF6",
            "gridcolor": "white",
            "gridwidth": 2,
            "linecolor": "white",
            "showbackground": true,
            "ticks": "",
            "zerolinecolor": "white"
           },
           "zaxis": {
            "backgroundcolor": "#E5ECF6",
            "gridcolor": "white",
            "gridwidth": 2,
            "linecolor": "white",
            "showbackground": true,
            "ticks": "",
            "zerolinecolor": "white"
           }
          },
          "shapedefaults": {
           "line": {
            "color": "#2a3f5f"
           }
          },
          "ternary": {
           "aaxis": {
            "gridcolor": "white",
            "linecolor": "white",
            "ticks": ""
           },
           "baxis": {
            "gridcolor": "white",
            "linecolor": "white",
            "ticks": ""
           },
           "bgcolor": "#E5ECF6",
           "caxis": {
            "gridcolor": "white",
            "linecolor": "white",
            "ticks": ""
           }
          },
          "title": {
           "x": 0.05
          },
          "xaxis": {
           "automargin": true,
           "gridcolor": "white",
           "linecolor": "white",
           "ticks": "",
           "title": {
            "standoff": 15
           },
           "zerolinecolor": "white",
           "zerolinewidth": 2
          },
          "yaxis": {
           "automargin": true,
           "gridcolor": "white",
           "linecolor": "white",
           "ticks": "",
           "title": {
            "standoff": 15
           },
           "zerolinecolor": "white",
           "zerolinewidth": 2
          }
         }
        },
        "width": 800
       }
      }
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      ":)\n"
     ]
    }
   ],
   "source": [
    "# Define grouping functions to be passed into create_hdf5_file function. These can also be set\n",
    "# as strings refering to categorical columns in input_data_df.\n",
    "\n",
    "test_grouping_funcs = True\n",
    "if test_grouping_funcs:\n",
    "    group_by_sample = lambda x : utils.group_by_df_column(x,'sample')\n",
    "    group_by_type = lambda x : utils.group_by_df_column(x,'filetype')\n",
    "    group_by_filenumber = lambda x : utils.group_by_df_column(x,'filenumber')\n",
    "else:\n",
    "    group_by_sample = 'sample'\n",
    "    group_by_type = 'filetype'\n",
    "    group_by_filenumber = 'filenumber'\n",
    "\n",
    "output_filename = 'test.h5'\n",
    "\n",
    "ofilepath = os.path.join(output_dir_path,output_filename)\n",
    "\n",
    "h5lib.create_hdf5_file_from_dataframe(ofilepath,\n",
    "                       input_data_df, 'top-down', \n",
    "                       group_by_funcs = [group_by_sample, group_by_type, group_by_filenumber]\n",
    "                       )\n",
    "\n",
    "annotation_dict = {'Campaign name': 'SLS-Campaign-2023',\n",
    "                    'Producers':'Thorsten, Luca, Zoe',\n",
    "                    'Startdate': str(input_data_df['lastModifiedDatestr'].min()),\n",
    "                    'Enddate': str(input_data_df['lastModifiedDatestr'].max())\n",
    "                    }\n",
    "h5lib.annotate_root_dir(ofilepath,annotation_dict)\n",
    "\n",
    "h5lib.display_group_hierarchy_on_a_treemap(ofilepath)\n",
    "\n",
    "print(':)')\n"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "test_atmos_chem_env",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.6"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
